<template>
  <div class="purchaseReturn pagePadding">
    <div
      v-if=" powers.some((i) => i == '001')"
    >
      <ex-table
        v-loading="loading"
        :table="table"
        :data="tableData"
        :columns="columns"
        :page="pageInfo"
        :size="size"
        @page-curr-change="handlePageChange"
        @page-size-change="handleSizeChange"
        @screen-reset="
          pageInfo.curr = 1;
          parmValue.page = 1;
          searchList();
        "
        @screen-submit="
          pageInfo.curr = 1;
          parmValue.page = 1;
          searchList();
        "
      >
        <template #table-header="{}">
          <div style="width: 100%">
            <el-row style="padding: 0 0 0 80px">
              <!-- <el-col :span="4" style="width: 150px; padding: 0 0 0 0px">
                <el-select
                  :size="searchSize"
                  v-model="parmValue.status"
                  filterable
                  clearable
                  placeholder="状态"
                  style="width: 100%"
                  @change="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();
                  "
                >
                  <el-option
                    v-for="item in statusOptions"
                    :key="'status' + item.id"
                    :label="item.label"
                    :value="item.id"
                  />
                </el-select>
              </el-col> -->
              <!-- 下拉筛选 -->
              <el-col :span="6" style="width: 400px; ">
                <el-input
                  clearable
                  placeholder="关键字"
                  v-model="s_input"
                  maxlength="40"
                  :size="searchSize"
                  class="input-with-select"
                >
                  <el-select
                    v-model="select"
                    style="width: 125px"
                    slot="prepend"
                    placeholder="关键字类型"
                    @change="
                      pageInfo.curr = 1;
                      parmValue.page = 1;
                      searchList();
                    "
                  >
                    <el-option
                      label="退货单编号"
                      value="returnCode"
                    ></el-option>
                    <el-option label="采购单编号" value="cgdNo"></el-option>
                    <el-option
                      label="商品属性编码"
                      value="good_type_code"
                    ></el-option>
                    <el-option label="商品名称" value="good_name"></el-option>
                  </el-select>
                  <el-button
                    slot="append"
                    icon="el-icon-search"
                    @click="handleValue"
                  ></el-button>
                </el-input>
              </el-col>

              <el-col :span="3" style="width: 66px; float: right">
                <el-button
                  :size="searchSize"
                  type="primary"
                  style="float: right; margin-left: 5px"
                  @click="searchList"
                >
                  刷新
                </el-button>
              </el-col>
              <el-col
                :span="4"
                class="fr"
                style="width: 66px; padding: 0 0 0 10px"
              >
                <el-button
                  type="warning"
                  class="fr"
                  :size="searchSize"
                  @click="restSearch"
                >
                  重置
                </el-button>
              </el-col>
            </el-row>
          </div>
        </template>
       
        <template #order_type="{ scope }">
        
          <p
            v-text="
              (
                cg_order_type_options.find(
                  (item) => item.id == scope.row.order_type
                ) || {}
              ).label || '--'
            "
          ></p>
        </template>
        <template #operation="{ scope }">
          <el-tooltip
            v-if="powers.some((i) => i == '007')"
            effect="dark"
            content="详情"
            placement="top"
          >
            <i
              class="el-icon-view tb-icon"
              
               @click="getRouter('purchaseReturnDetail', scope.row.returnCode )"
            ></i>
          </el-tooltip>
          <el-tooltip
            v-if="powers.some((i) => i == '005')"
            effect="dark"
            content="修改"
            placement="top"
          >
            <i
              class="el-icon-edit tb-icon"
              @click="openModal(scope.row.id, false, scope.row)"
            ></i>
          </el-tooltip>
          <el-tooltip
            v-if="
              powers.some((i) => i == '004') && scope.row.status === '1'
            "
            effect="dark"
            content="禁用"
            placement="top"
          >
            <i
              class="el-icon-video-pause tb-icon"
              @click="statusConfirm(scope.row.id, scope.row.status)"
            ></i>
          </el-tooltip>
          <el-tooltip
            v-if="
              powers.some((i) => i == '004') && scope.row.status === '0'
            "
            effect="dark"
            content="启用"
            placement="top"
          >
            <i
              class="el-icon-video-play tb-icon"
              @click="statusConfirm(scope.row.id, scope.row.status)"
            ></i>
          </el-tooltip>
        </template>
      </ex-table>
    </div>
    <div v-else>
      <no-auth></no-auth>
    </div>
  </div>
</template>
   <script>
import mixinPage from "@/mixins/elPaginationHandle";
import resToken from "@/mixins/resToken";
import columns from "./columns";
import asyncRequest from "@/apis/service/purchaseIn/purchaseReturn";
import { mapGetters } from "vuex";
import { cg_order_type_options } from "@/assets/js/statusList";
export default {
  name: "purchaseReturn",
  mixins: [mixinPage, resToken],
  computed: {
    ...mapGetters(["tablebtnSize", "searchSize", "size"]),
    powers() {
      const tran =
        this.$store.getters.btnList.find(
          (item) => item.menu_route == "purchaseReturn"
        ) || {};
      const { action } = tran ?? {};
      return action ?? [];
    },
  },
  data() {
    return {
      select: "returnCode", //默认选择下拉框
      s_input: "", //搜索框内容
      sitem: null,
      // 状态
      statusOptions: [
        // { id: "0", label: "禁用" },
        { id: "1", label: "待发起审核" },
        { id: "2", label: "待业务审核" },
        // { id: "1", label: "待业务审核" },
        { id: "3", label: "待通知财务" },
        // { id: "2", label: "待通知库管" },
        { id: "4", label: "待填写物流" },
        // { id: "3", label: "待通知采购" },
        // { id: "4", label: "待通知财务" },
        // { id: "5", label: "完成退货" },
      ],
      cg_order_type_options,
      loading: true,
      showModel: false,
      isDetail: false,
      modelId: 0,
      parmValue: {
        cgdNo: "", //采购单编号
        returnCode: "", //退货单编号
        good_type_code: "", //商品属性编号
        good_name: "", //商品名称
        status: "", //节点状态
        status: "", //节点状态
        page: 1, // 页码
        size: 15, // 每页显示条数
      },
      // 表格 - 数据
      tableData: [],
      // 表格 - 参数
      table: {
        stripe: true,
        border: true,
        _defaultHeader_: ["setcol"],
      },
      // 表格 - 分页
      pageInfo: {
        size: 15,
        curr: 1,
        total: 0,
      },
      // 表格 - 列参数
      columns: columns,
    };
  },
  mounted() {
    const { back } = this.$route.query;
    if (back) {
      this.parmValue = JSON.parse(back);
      console.log(this.parmValue)
      const {page,size}=this.parmValue;
      // this.timeOBJ.start = start || last_start;
      // this.timeOBJ.end = end || last_end;
     
       this.pageInfo= {
        size: size,
        curr: page,
        total: 0,
      }
      //多选条件
    this.select = this.parmValue.select;
    // this.sselect = this.parmValue.sselect;
    this.input = this.parmValue.input


    
    
   
    }else{
       this.select = "returnCode";
    }
    this.searchList();
  },

  methods: {
    getRouter(toRouter, queryId){
      if (toRouter && queryId) {
        let model = {
          id: queryId,
        };

        //有多选框的条件
        this.parmValue.select = this.select ;
        // this.parmValue.sselect = this.sselect ;
        this.parmValue.s_input= this.s_input;

        //
         let routerModel = {
          options: JSON.parse(JSON.stringify(this.parmValue)),
          router: this.$route.path,
        };
        model.preModel = JSON.stringify(routerModel);
        
        this.routeGoto(toRouter, model);
      } else {
        this.$message.warning("暂未找到相关流程！");
      }
    },
    restSearch() {
      this.s_input = ""; //清除输入框内容
      this.select = "returnCode"; //清除下拉框选中项
      this.parmValue = {
        cgdNo: "", //采购单编号
        returnCode: "", //退货单编号
        good_type_code: "", //商品属性编号
        good_name: "", //商品名称
        status: "", //节点状态
        page: 1, // 页码
        size: 15, // 每页显示条数
      };
      // 表格 - 分页
      this.pageInfo = {
        size: 15,
        curr: 1,
        total: 0,
      };
      this.searchList();
    },

    openModal(id, isDetail, sitem) {
      this.showModel = true;
      this.modelId = id;
      this.isDetail = isDetail;
      this.sitem = sitem;
    },
    async deleteById(id, status) {
      await this.$confirm("确定要删除？", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          const model = {
            id: id,
            status: status === "1" ? "0" : "1",
          };
          const res = await asyncRequest.status(model);
          if (res && res.code === 0) {
            this.$notify.success({
              title: "删除成功",
              message: "",
            });
            this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    async searchList() {
      this.loading = true;
      let model = JSON.parse(JSON.stringify(this.parmValue));
      const res = await asyncRequest.list(model);
      if (res && res.code === 0 && res.data) {
        this.tableData = res.data.list;
        this.pageInfo.total = Number(res.data.count);
        this.tableData.forEach((v) => {
          v.good_class = "";
          if (v.can && v.can.length > 0) {
            v.can.forEach((x, i) => {
              v.good_class += i === 0 ? x.name : "/" + x.name;
            });
          }
        });
      } else if (res && res.code >= 100 && res.code <= 104) {
        await this.logout();
      } else {
        this.tableData = [];
        this.pageInfo.total = 0;
      }
      this.loading = false;
    },

    async statusConfirm(id, status) {
      let str = status === "1" ? "禁用" : "启用";
      await this.$confirm("确定要改为" + str + "?", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          this.loading = true;
          const model = {
            id: id,
            status: status === "1" ? "0" : "1",
          };
          const res = await asyncRequest.status(model);
          if (res && res.code === 0) {
            this.loading = false;
            this.$notify.success({
              title: "状态修改成功！",
              message: "",
            });
            await this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    //物流公司查询
    async handleCompany(e) {
      console.log(e, "要求传快递简称，不传id"); //
      if (e && e.code) {
        this.parmValue.postCompany = [e.shortName];
        this.parmValue.page = 1;
      }
      console.log(this.parmValue.postCompany);
      await this.searchList();
    },
    async handleValue() {
      this.parmValue.returnCode =
        this.select === "returnCode" ? this.s_input : "";
      this.parmValue.cgdNo = this.select === "cgdNo" ? this.s_input : "";
      this.parmValue.good_type_code =
        this.select === "good_type_code" ? this.s_input : "";
      this.parmValue.good_name =
        this.select === "good_name" ? this.s_input : "";

      await this.searchList();
    },
    // 时间
    async handleTime(e) {
      if (e.startTime !== "") {
        this.parmValue.start = e.startTime;
      } else {
        this.parmValue.start = "";
      }
      if (e.endTime !== "") {
        this.parmValue.end = e.endTime;
      } else {
        this.parmValue.end = "";
      }
      if (this.parmValue.start !== "" && this.parmValue.end !== "") {
        this.parmValue.page = 1;
        await this.searchList();
      }
    },
  },
};
</script>
   <style lang="scss" scoped>
.sellReturn {
}
</style>
   